<?php
	/*
	Plugin Name: Youtube Sidebar Widget
	Plugin URI: http://wordpress.org/extend/plugins/youtube-sidebar-widget/
	Description: List video thumbnails from Youtube in your WordPress theme using widgets 
	Version: 1.1.1
	Author: Stephen Coley
	Author URI: http://coley.co

	Copyright 2010  DK New Media  (email : stephen@dknewmedia.com)

	This program is free software; you can redistribute it and/or modify
	it under the terms of the GNU General Public License, version 2, as 
	published by the Free Software Foundation.

	This program is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with this program; if not, write to the Free Software
	Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
	*/

	class YoutubeSidebarWidget extends WP_Widget {

		function YoutubeSidebarWidget() {
			parent::WP_Widget(false, $name = 'Youtube Sidebar Widget');	
		}

		function widget($args, $instance) {		

			error_reporting(E_ALL);
			ini_set('display_errors', '1');

			extract( $args );
			$title = apply_filters('widget_title', $instance['title']);
			$un = esc_attr($instance['username']);
			$titles = esc_attr($instance['titles']);
			$num = esc_attr($instance['num_videos']); 
			$fil = esc_attr($instance['filter']);
			$rss_url = "http://gdata.youtube.com/feeds/base/users/$un/uploads?alt=rss&amp;v=2&amp;orderby=published&amp;client=ytapi-youtube-profile";
			$simple_xml = simplexml_load_file($rss_url);
			echo $before_widget;
			if($title) {
				echo $before_title . $title . $after_title;
			}
			
			$output = "<div id='youtube-sidebar-widget'>\n\r<ul>\n\r";
			$i = 1;
			foreach($simple_xml->channel->item as $item){
				if($fil) {
					if(strpos($item->description, $fil)) {
						if($i <= $num) {
							$link = explode("/watch?v=", $item->link);
							$hash = explode("&", $link[1]);
							$img = "http://i2.ytimg.com/vi/$hash[0]/0.jpg";

							if($titles == "yes") {
								$output .= "<li id='$hash[0]'><img src='$img' alt='$item->title' desc='" . strip_tags($item->description) . "' /><div class='play_arrow'></div>\n\r<a href='#'>$item->title</a>";
							} else {
								$output .= "<li id='$hash[0]'><img src='$img' alt='$item->title' desc='" . strip_tags($item->description) . "' /><div class='play_arrow'></div>\n\r";
							}
							
							$i++;
						} else {
							break;
						}
					}
				} else {
					if($i <= $num) {
						$link = explode("/watch?v=", $item->link);
						$hash = explode("&", $link[1]);
						$img = "http://i2.ytimg.com/vi/$hash[0]/0.jpg";

						if($titles == "yes") {
							$output .= "<li id='$hash[0]'><img src='$img' alt='$item->title' desc='" . strip_tags($item->description) . "' /><div class='play_arrow'></div>\n\r<a href='#'>$item->title</a>";
						} else {
							$output .= "<li id='$hash[0]'><img src='$img' alt='$item->title' desc='" . strip_tags($item->description) . "' /><div class='play_arrow'></div>\n\r";
						}
						
						$i++;
					} else {
						break;
					}
				}
			}
			$output .= "</ul>\n\r</div>\n\r";
			echo $output;
			echo $after_widget;
		}

		function update($new_instance, $old_instance) {				
			$instance = $old_instance;
			$instance['title'] = strip_tags($new_instance['title']);
			$instance['username'] = strip_tags($new_instance['username']);
			$instance['titles'] = strip_tags($new_instance['titles']);
			$instance['num_videos'] = strip_tags($new_instance['num_videos']);
			$instance['filter'] = strip_tags($new_instance['filter']);
			return $instance;
		}

		function form($instance) {				
			$instance = wp_parse_args( (array) $instance, array('title'=>'', 'username'=>'', 'num_videos'=>'2', 'filter'=>'') );

			$title = esc_attr($instance['title']);
			$un = esc_attr($instance['username']);
			$num = esc_attr($instance['num_videos']); 
			$fil = esc_attr($instance['filter']); ?>

			<p>
				<label for="<?php echo $this->get_field_id('title'); ?>"><?php _e('Title:'); ?></label> 
				<input class="widefat" id="<?php echo $this->get_field_id('title'); ?>" name="<?php echo $this->get_field_name('title'); ?>" type="text" value="<?php if(isset($title)) { echo $title; } ?>" />
			</p>
			<p>
				<label for="<?php echo $this->get_field_id('username'); ?>"><?php _e('Username:'); ?></label> 
				<input class="widefat" id="<?php echo $this->get_field_id('username'); ?>" name="<?php echo $this->get_field_name('username'); ?>" type="text" value="<?php if(isset($un)) { echo $un; } ?>" />
			</p> 
			<p>
				<label for="<?php echo $this->get_field_id('titles'); ?>"><?php _e('Display Titles:'); ?></label> 
				<select class="widefat" id="<?php echo $this->get_field_id('titles'); ?>" name="<?php echo $this->get_field_name('titles'); ?>">
					<option value='yes' <?php if($titles == "yes") { echo "selected='selected'"; } ?> >yes</option>
					<option value='no' <?php if($titles == "no") { echo "selected='selected'"; } ?> >no</option>
				</select>
			</p>
			<p>
				<label for="<?php echo $this->get_field_id('num_videos'); ?>"><?php _e('Number to Display:'); ?></label> 
				<select class="widefat" id="<?php echo $this->get_field_id('num_videos'); ?>" name="<?php echo $this->get_field_name('num_videos'); ?>">
					<?php for($i = 1; $i <= 10; $i++) {
						if($num == $i) {
							echo "<option value='$i' selected='selected'>$i</option>";
						} else {
							echo "<option value='$i'>$i</option>";
						}
					} ?>
				</select>
			</p>
			<p>
				<label for="<?php echo $this->get_field_id('filter'); ?>"><?php _e('Filter:'); ?></label> 
				<input class="widefat" id="<?php echo $this->get_field_id('filter'); ?>" name="<?php echo $this->get_field_name('filter'); ?>" type="text" value="<?php if(isset($fil)) { echo $fil; } ?>" />
			</p>
		 <?php }

	}

	function ysw_init() {
		if (!is_admin()) {
			wp_enqueue_script('jquery');
		}
	}	

	function ysw_head() {
		echo "<link rel='stylesheet' href='" . get_bloginfo('url') . "/wp-content/plugins/youtube-sidebar-widget/style.css' />";
		wp_enqueue_script('jquery');
	}

	function ysw_footer() {
		echo "<script type='text/javascript' src='" . get_bloginfo('url'). "/wp-content/plugins/youtube-sidebar-widget/script.js'></script>";
	}

	add_action('widgets_init', create_function('', 'return register_widget("YoutubeSidebarWidget");'));
	add_action('init', 'ysw_init');
	add_action('wp_head', 'ysw_head');
	add_action('wp_footer', 'ysw_footer');
	

?>
